//
// JobsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class JobsAPI {
    /**
     * enum for parameter filterStatus
     */
    public enum FilterStatus_getJobs: String { 
        case scheduling = "scheduling"
        case scheduled = "scheduled"
        case processing = "processing"
        case halted = "halted"
        case locked = "locked"
        case canceled = "canceled"
        case finished = "finished"
        case error = "error"
    }

    /**
     * enum for parameter sortField
     */
    public enum SortField_getJobs: String { 
        case jobid = "jobId"
        case title = "title"
        case createtime = "createTime"
        case timetosend = "timeToSend"
        case timetosenduntil = "timeToSendUntil"
    }

    /**
     * enum for parameter sortOrder
     */
    public enum SortOrder_getJobs: String { 
        case asc = "asc"
        case desc = "desc"
    }

    /**
     /jobs

     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterSameAccount: (query) Query parameter to fetch jobs after the api account linked to the used token/key for authorization (optional, default to false)
     - parameter filterTitle: (query) Query parameter to fetch jobs after his title (optional)
     - parameter filterStatus: (query) Query parameter to fetch jobs after his status (optional)
     - parameter filterDateFrom: (query) Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) (optional)
     - parameter filterDateTo: (query) Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 (optional)
     - parameter filterDateUntilFrom: (query) Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) (optional)
     - parameter filterDateUntilTo: (query) Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 (optional)
     - parameter filterCostCenter: (query) Query parameter to fetch jobs after his cost center (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJobs(objectLimit: Int? = nil, objectOffset: Int? = nil, filterSameAccount: Bool? = nil, filterTitle: String? = nil, filterStatus: FilterStatus_getJobs? = nil, filterDateFrom: Date? = nil, filterDateTo: Date? = nil, filterDateUntilFrom: Date? = nil, filterDateUntilTo: Date? = nil, filterCostCenter: String? = nil, sortField: SortField_getJobs? = nil, sortOrder: SortOrder_getJobs? = nil, completion: @escaping ((_ data: Jobs?,_ error: Error?) -> Void)) {
        getJobsWithRequestBuilder(objectLimit: objectLimit, objectOffset: objectOffset, filterSameAccount: filterSameAccount, filterTitle: filterTitle, filterStatus: filterStatus, filterDateFrom: filterDateFrom, filterDateTo: filterDateTo, filterDateUntilFrom: filterDateUntilFrom, filterDateUntilTo: filterDateUntilTo, filterCostCenter: filterCostCenter, sortField: sortField, sortOrder: sortOrder).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs
     - GET /jobs

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "total" : 100,
  "offset" : 0,
  "data" : [ {
    "options" : {
      "faxHeader" : true,
      "saveDocuments" : false,
      "faxHeaderFrom" : "Max Mustermann",
      "defaultInternationalDialingCode" : "0049",
      "costCenter" : "Kösten",
      "timeToSend" : "2022-01-01T10:00:00+02:00",
      "title" : "Fax Job ABC 123",
      "timeToSendUntil" : "2030-01-01T10:00:00+02:00",
      "clip" : "0525187929310",
      "stationID" : "test12345"
    },
    "errorCode" : 503,
    "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
    "account" : "ApiAccount123",
    "status" : "scheduling",
    "info" : {
      "templateIsAvailable" : true,
      "previewIsAvailable" : true
    },
    "statistics" : {
      "surcharge" : 1,
      "recipientCountSuccessful" : 8,
      "recipientCountError" : 2,
      "pages" : 1,
      "recipientCount" : 10
    }
  }, {
    "options" : {
      "faxHeader" : true,
      "saveDocuments" : false,
      "faxHeaderFrom" : "Max Mustermann",
      "defaultInternationalDialingCode" : "0049",
      "costCenter" : "Kösten",
      "timeToSend" : "2022-01-01T10:00:00+02:00",
      "title" : "Fax Job ABC 123",
      "timeToSendUntil" : "2030-01-01T10:00:00+02:00",
      "clip" : "0525187929310",
      "stationID" : "test12345"
    },
    "errorCode" : 503,
    "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
    "account" : "ApiAccount123",
    "status" : "scheduling",
    "info" : {
      "templateIsAvailable" : true,
      "previewIsAvailable" : true
    },
    "statistics" : {
      "surcharge" : 1,
      "recipientCountSuccessful" : 8,
      "recipientCountError" : 2,
      "pages" : 1,
      "recipientCount" : 10
    }
  } ],
  "count" : 50
}}]
     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterSameAccount: (query) Query parameter to fetch jobs after the api account linked to the used token/key for authorization (optional, default to false)
     - parameter filterTitle: (query) Query parameter to fetch jobs after his title (optional)
     - parameter filterStatus: (query) Query parameter to fetch jobs after his status (optional)
     - parameter filterDateFrom: (query) Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) (optional)
     - parameter filterDateTo: (query) Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 (optional)
     - parameter filterDateUntilFrom: (query) Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+01:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00) (optional)
     - parameter filterDateUntilTo: (query) Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like &#x27;2022-01-01T10:00:00+02:00&#x27;. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00 (optional)
     - parameter filterCostCenter: (query) Query parameter to fetch jobs after his cost center (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)

     - returns: RequestBuilder<Jobs> 
     */
    open class func getJobsWithRequestBuilder(objectLimit: Int? = nil, objectOffset: Int? = nil, filterSameAccount: Bool? = nil, filterTitle: String? = nil, filterStatus: FilterStatus_getJobs? = nil, filterDateFrom: Date? = nil, filterDateTo: Date? = nil, filterDateUntilFrom: Date? = nil, filterDateUntilTo: Date? = nil, filterCostCenter: String? = nil, sortField: SortField_getJobs? = nil, sortOrder: SortOrder_getJobs? = nil) -> RequestBuilder<Jobs> {
        let path = "/jobs"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "objectLimit": objectLimit?.encodeToJSON(), 
                        "objectOffset": objectOffset?.encodeToJSON(), 
                        "filterSameAccount": filterSameAccount, 
                        "filterTitle": filterTitle, 
                        "filterStatus": filterStatus?.rawValue, 
                        "filterDateFrom": filterDateFrom?.encodeToJSON(), 
                        "filterDateTo": filterDateTo?.encodeToJSON(), 
                        "filterDateUntilFrom": filterDateUntilFrom?.encodeToJSON(), 
                        "filterDateUntilTo": filterDateUntilTo?.encodeToJSON(), 
                        "filterCostCenter": filterCostCenter, 
                        "sortField": sortField?.rawValue, 
                        "sortOrder": sortOrder?.rawValue
        ])


        let requestBuilder: RequestBuilder<Jobs>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     /jobs

     - parameter body: (body) Describes the required request body to create a new fax job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postJob(body: JobPost, completion: @escaping ((_ data: InlineResponse201?,_ error: Error?) -> Void)) {
        postJobWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs
     - POST /jobs

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
  "target" : ".../jobs/{id}"
}}]
     - parameter body: (body) Describes the required request body to create a new fax job 

     - returns: RequestBuilder<InlineResponse201> 
     */
    open class func postJobWithRequestBuilder(body: JobPost) -> RequestBuilder<InlineResponse201> {
        let path = "/jobs"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<InlineResponse201>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
